#{extends 'border.html'/}
<div class="container">

    <style>
        .loader {
            border: 5px solid #f3f3f3;
            border-radius: 50%;
            border-top: 5px solid #3498db;
            width: 30px;
            height: 30px;
            -webkit-animation: spin 2s linear infinite; /* Safari */
            animation: spin 2s linear infinite;
        }

        /* Safari */
        @-webkit-keyframes spin {
        0% { -webkit-transform: rotate(0deg); }
        100% { -webkit-transform: rotate(360deg); }
        }

        @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
        }
    </style>

	<div class="row">
		<div class="col-md-12">
			<!-- Breadcrumb -->
		    <ol class="breadcrumb">
		        <li><a href="@{PublikCtr.index()}">&{'beranda.label'}</a></li>
		        <li class="active"><a href="@{admin.KomoditasCtr.index()}">&{'komoditas.label'}</a></li>
		        <li class="active">&{'tambah.label'} &{'komoditas.label'}</li>
		    </ol>
		    <!-- End Breadcrumb -->
		    
		    #{alert /}
		</div>
	</div>
    
    <div class="row">
    	<div class="wizard-form-wrapper">
	    	<div class="padded">
		        <div id="rootwizard">
		        	<div class="wizard-header">
		        		<div class="row">
		        			<div class="col-md-2">
		        				<h4>&{'tambah.label'} &{'komoditas.label'}</h4>
		        			</div>

		        		</div>
			    	</div>
			    	
			    	<div class="wizard-body">
                        <div class="alert-container"></div>
			    		<div class="panel panel-default">
			    			<div class="panel-body">
			    				<div class="form-horizontal">
			    					#{form @admin.KomoditasCtr.createSubmit(), method:'POST', class:'form_create'}
										<input type="hidden" name="form.komoditas.active" value="false" id="komoditas-active" />
										<input type="hidden" name="form.komoditas.id" id="komoditas-id" />
										<input type="hidden" name="form.komoditas.status" id="komoditas-status" />
										#{include 'pl/data-komoditas/tab-formkomoditas.html' /}
										<div class="btn-group pull-right" role="group" aria-label="Basic example">
											<button id="save" class="btn btn-primary radius-4">&{'simpan.label'}</button>
										</div>
										<button id="form-submit" type="submit" style="display: none"></button>
							        #{/form}
			    				</div>
			    			</div>
			    		</div>
			    	</div>
		        </div>
		    </div>
	    </div>
    </div>    

</div>
*{#{include 'admin/UsulanCtr/parts/_jsPart.html'/}}*

#{validationPackage/}

#{set 'moreScripts'}
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
<script src="@{'/public/javascripts/jquery.mjs.nestedSortable.js'}" type="text/javascript"> </script>
<script src="@{'/public/javascripts/ckeditor/ckeditor.js'}" type="text/javascript"> </script>
<script type="text/javascript" src="@{'public/javascripts/toast/jquery.toast.min.js'}"></script>
<script type="text/javascript">
    var pleaseSelctLabel = `&{'pilih.label'}`;
    var kategori_index = 1;
    var tipeAtributJson = "";
    var isKategoriChange = false;
    var formHtmlAtributKategori = `#{include "/admin/ProdukKategoriAtributCtr/_formInput.html" /}`;
    var removeDokSource  = #{jsRoute @admin.usulanCtr.hapusDoc() /};
    var counterManufaktur = ${form.manufaktur ? form.manufaktur.length : 0};
    var counterTipeAtribut = ${form.tipeAtribut ? form.tipeAtribut.length : 0};
    var index = ${atributHarga?.nama_atribut != null ? atributHarga?.nama_atribut?.size() : 0};
    var atributKategoriObj = {};
    var counterTemplateJadwal = ${form.jadwal ? form.jadwal.size() : 0};
    var jadwalIndex = counterTemplateJadwal;
    var uploadDokumenUsulanUrl = '@{admin.usulanCtr.upload()}';
    var totalUploaded = ${dokumenInfoList != null ? dokumenInfoList.size() : 0};
    var isLelangOrDatafeed = false;
    var datafeedId = ${datafeed};
    var katalogId = ${katalog};
    var tahapanObj = [];
    var selectedPenawaran = null;
    var selectedNego = null;
    var tahapanJson = '${tahapanJson.raw()}';
    var tahapanArray = JSON.parse(tahapanJson);

    var params = {};
    params['validasiNamaKomoditas'] = '@{admin.KomoditasCtr.validasiKomoditas()}';
    params.uploadDocUrl      = '@{admin.UsulanCtr.upload()}';
    params.deleteDocUrl      = '@{admin.UsulanCtr.hapusDoc()}';
    //ada di js part, tapi saling tumpang tindih, karena disana juga import usulan.js

    var totalPokjaUploaded = ${dokumenInfoPokjaList != null ? dokumenInfoPokjaList.size() : 0};
    params.uploadDocPokjaUrl = '@{admin.UsulanCtr.uploadPokja()}';

    jQuery(function () {
        jQuery.getScript("@{'/public/javascripts/module/komoditas/komoditas.js'}");
    });

    jQuery(function () {
        jQuery.getScript("@{'/public/javascripts/module/komoditas/komoditas-atribut-harga.js'}");
    });

    $(document).ready(function() {
        getKldi();
    	$(window).keydown(function(event){
			if(event.keyCode == 13) {
			  event.preventDefault();
			  return false;
			}
		});

        var v1 = $('input[name="form.komoditas.nama_komoditas"]');
        function cekVal1Val(){
            if(v1.val() != null){
                validateOnServer(v1);

            }
        }
        v1.blur(function(){
            cekVal1Val();
        });

        $("#save").on("click", function (e) {
        	e.preventDefault()
        	$('#komoditas-status').val('publish')
            $('#form-submit').click()
        })

        $("#draft").on("click", function (e) {
        	e.preventDefault()
        	$('#komoditas-status').val('draft')
            $('#form-submit').click()
        })

        function automatedSaving() {
			let form = new FormData($('.form_create')[0])

			$.ajax({
				type: 'POST',
				url: '@{admin.KomoditasCtr.automatedSaving()}',
				data: form,
				enctype: 'multipart/form-data',
				processData: false,
				contentType: false,
				cache: false,
				success: function(result){
					if (result.status && result.payload != null) {
						$('#komoditas-id').val(result.payload.id)
					}
				},
				error: function(data) {
				}
			})
		}

        jQuery(function () {
            jQuery.getScript("@{'/public/javascripts/module/usulan/komoditas_usulan.js'}");
        });

        $(".akses-external-url").on("click", function () {
            var radio = $(this).val();
            if(radio == 1){
                $("#external-url").prop('required',true);
                $(".external-url").show();
            }else{
                $("#external-url").prop('required',false);
                $("#external-url").parents('.form-group').removeClass('has-error');
                $("#external-url-error").remove();
                $(".external-url").hide();
            }
        });

        jQuery(function () {
            jQuery.getScript("@{'/public/javascripts/module/komoditas/validation/komoditas-validation.js'}");
        });

        $('#rootwizard').bootstrapWizard({
            onTabShow : function(tab, navigation, index) {
            	$('.next').show();
                $('.simpan').hide();
                var $total = navigation.find('li').length;
                var $current = index + 1;
                var $percent = ($current / $total) * 100;
                $('#rootwizard .progress-bar').css({
                    width : $percent + '%'
                });
                if($current === $total) {
                    $('.next').hide();
                    $('.simpan').css('float', 'right');
                    $('.simpan').show();
                }
                if (index !== 0) {
					automatedSaving()
				}
            },
            onNext: function(tab, navigation, index){
                var currentIndex = index - 1;
                return validateTab(currentIndex);

            },
            onTabClick: function(activeTab, navigation, currentIndex, nextIndex) {
                // console.log(activeTab);
                if (nextIndex <= currentIndex) {
                    return;
                }
                if (nextIndex > currentIndex+1){
                    for(var i = currentIndex;i < nextIndex; i++){
                        if(!validateTab(i)){
                            // console.log(i);
                            if(i > currentIndex){
                                $("#index-"+i).click();
                            }
                            return false;
                        }
                    }
                    return true;
                }
                return validateTab(currentIndex);
            }
        });

        $('#nama_komoditas').on("blur", function(){
        	let value = $('#nama_komoditas').val()
        	if (value == null || value === '') {
        		return
        	}
        	$('#loadingName').show();
            var xhr = new XMLHttpRequest();
            xhr.withCredentials = false;
            xhr.open('POST', '@{admin.KomoditasCtr.generateKode()}');

            xhr.onload = function() {
                if (xhr.status != 200) {
                    failure('HTTP Error: ' + xhr.status);
                    return;
                }

                var kode = xhr.responseText;
                $("#kode_komoditas").val(kode);
                $("#kode_komoditasDis").val(kode);
				$('#loadingName').hide();
            };

            var formData = new FormData();
            formData.append('nama', $('#nama_komoditas').val());

            xhr.send(formData);
        })
        $('.sortable').nestedSortable({
            handle: 'div',
            items: 'li',
            maxLevels: 5,
            toleranceElement: '> div',
            relocate: function() {
                isKategoriChange = true;
            }
        });

        $('.disclose').on('click', function() {
            $(this).closest('li').toggleClass('mjs-nestedSortable-collapsed').toggleClass('mjs-nestedSortable-expanded');
        })
    });

    function validateOnServer(v1){
        //data.override = true;
        var nama = $('input[name="form.komoditas.nama_komoditas"]').val();
        var urls = params.validasiNamaKomoditas+'?nama='+nama;


        if(nama != null && name !== ''){

            $.ajax({
                type: 'GET',
                url: urls,
                success : function(datas){
                    $('#alert-upload').hide();
                    if(!datas.valid){//if notvalid
                        showAlert(true, datas.message);
                        var nama1 = "Nama Komoditas";
                        if(datas.message.indexOf(nama1) != -1){
                            v1.val(null);
                        }

                        $('#loadingName').hide();
                    }else{
                        showAlert(false, '');
                        $('#loadingName').hide();
                    }
                    return !datas.valid;
                },
                error : function(){
                    $('#alert-upload').html('<div class="alert alert-danger" role="alert">gagal validasi Nama Komoditas</div>');
                    $('#loadingName').hide();
                }
            })
        }
    }

    function getKldi() {
        $('#kategoriKomoditas').on('change', function() {
            if(this.value == 5) {
                var labelLokalSek =  "&{'kabupaten_kota.label'}";
                $('#labelLokalSektoral').text(labelLokalSek);
                $('#selectKldi').show();
                $('#selectLocation').show();
                $(document).ajaxStart(function(){$.showLoading();});
                $.ajax({
                    url: "@{controllers.admin.KomoditasCtr.getKldi()}",
                    data: {
                        param: "lokal"
                    },
                    dataType: 'json',
                    success: function (res) {
                        // console.log(res);
                        $("#kldi").empty();
                        $("#lokasi-penyedia").empty();

                        for (var i = 0; i < res.length; i++) {
                            var obj = res[i];
                            $("#kldi").append(new Option(obj.nama, obj.id));
                            $("#lokasi-penyedia").append(new Option(obj.nama, obj.id));
                        }
                    }
                });
                //getKldiLocation();
                $(document).ajaxComplete(function(){$.hideLoading();});
            } else if (this.value == 6) {
                var labelLokalSek =  "&{'instansi.label'}";
                $('#labelLokalSektoral').text(labelLokalSek);
                $('#selectKldi').show();
                $('#selectLocation').show();
                $(document).ajaxStart(function(){$.showLoading();});
                $.ajax({
                    url: "@{controllers.admin.KomoditasCtr.getKldi()}",
                    data: {
                        param: "sektoral"
                    },
                    dataType: 'json',
                    success: function (res) {
                        // console.log(res);
                        $("#kldi").empty();
                        $("#lokasi-penyedia").empty();
                        for (var i = 0; i < res.length; i++) {
                            var obj = res[i];
                            $("#kldi").append(new Option(obj.nama, obj.id));
                            $("#lokasi-penyedia").append(new Option(obj.nama, obj.id));
                        }
                    }
                });
                //getKldiLocation();
                $(document).ajaxComplete(function(){$.hideLoading();});
            } else{
                $('#selectKldi').hide();
                $('#selectLocation').hide();
            }
        });
    }

    function getKldiLocation(){
        $.ajax({
            url: "@{controllers.admin.KomoditasCtr.getKldiLocation()}",
            data: {
                param: ""
            },
            dataType: 'json',
            success: function (res) {
                // console.log(res);
                $("#kldi").empty();

                for (var i = 0; i < res.length; i++) {
                    var obj = res[i];
                    $("#lokasi-penyedia").append(new Option(obj.nama, obj.id));
                }
            }
        });
    }

    function showAlert(status, message) {
        var container = $('.alert-container');
        if (status) {
            container.html('<div class="alert alert-danger fade in">\n' + message + '</div>');
            // setTimeout(function() {
            //     container.html('');
            // }, 5000);
        } else {
            container.html('');
        }
    }

</script>
#{/set}
